您的位置:首页 > 其它

Codeforces 792C Divide by Three【Dp+记录路径】

2017-03-29 20:01 274 查看
C. Divide by Three

time limit per test
1 second

memory limit per test
256 megabytes

input
standard input

output
standard output

A positive integer number n is written on a blackboard. It consists of not more than
105 digits. You have to transform it into a
beautiful number by erasing some of the digits, and you want to erase as few digits as possible.

The number is called beautiful if it consists of at least one digit, doesn't have leading zeroes and is a multiple of
3. For example, 0,
99, 10110 are beautiful numbers, and
00, 03,
122 are not.

Write a program which for the given n will find a beautiful number such that
n can be transformed into this number by erasing as few digits as possible. You can erase an arbitraty set of digits. For example, they don't have to go one after another in the number
n.

If it's impossible to obtain a beautiful number, print
-1. If there are multiple answers, print any of them.

Input
The first line of input contains n — a positive integer number without leading zeroes (1 ≤ n < 10100000).

Output
Print one number — any beautiful number obtained by erasing as few as possible digits. If there is no answer, print
 - 1.

Examples

Input
1033


Output
33


Input
10


Output
0


Input
11


Output
-1


Note
In the first example it is enough to erase only the first digit to obtain a multiple of
3. But if we erase the first digit, then we obtain a number with a leading zero. So the minimum number of digits to be erased is two.

题目大意:给你一个字符串,要求让你删除最少个数的元素,使得最终数字是没有前导0并且是3的倍数。

思路:

1、感觉Dp做这类题还是比较稳的。

设定dp【i】【3】=x表示:

①dp【i】【0】:【0~i】中剩余的数字每个位子相加模3为0的删除最少元素的个数。

②dp【i】【1】:【0~i】中剩余的数字每个位子相加模3为1的删除最少元素的个数。

③dp【i】【2】:【0~i】中剩余的数字每个位子相加模3为2的删除最少元素的个数。

2、那么就有:

dp【i】【j】=min(dp【i】【j】,dp【i-1】【((j-a[i]%3)%3+3)%3】);

因为既要注意前导0的情况,又要判断当前数字是几的情况,那么我们不妨将a[i]%3得到的值分成三类来处理:



代码略挫,细节都处理了。

3、回溯通过记录的路径,来反向记录结果即可。

Ac代码:

#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;
#define mod 3
int dp[1000500][3];
int pre[1000500][3];
char a[1000500];
char ans[1000500];
void init()
{
memset(pre,-1,sizeof(pre));
for(int i=0;i<1000000;i++)
{
for(int j=0;j<3;j++)
{
dp[i][j]=0x3f3f3f3f;
}
}
}
int main()
{
while(~scanf("%s",a))
{
int n=strlen(a);
if(n==1)
{
if((a[0]-'0')%3==0)printf("%c\n",a[0]);
else printf("-1\n");
continue;
}
init();
dp[0][0]=1;
dp[0][(a[0]-'0')%3]=0;
for(int i=1;i<n;i++)
{
for(int j=0;j<3;j++)
{
if(dp[i-1][j]+1<dp[i][j])dp[i][j]=dp[i-1][j]+1,pre[i][j]=j;
if((a[i]-'0')%3==0)
{
if(a[i]=='0')
{
if(dp[i-1][j]!=i)
{
if(dp[i-1][j]<dp[i][j])
{
dp[i][j]=dp[i-1][j];pre[i][j]=j;
}
}
}
else
{
if(dp[i-1][j]<dp[i][j])
{
dp[i][j]=dp[i-1][j];
pre[i][j]=j;
}
}
}
if((a[i]-'0')%3==1)
{
if(dp[i-1][((j-1)%mod+mod)%mod]<dp[i][j])
{
dp[i][j]=dp[i-1][((j-1)%mod+mod)%mod];
pre[i][j]=((j-1)%mod+mod)%mod;
}
}
if((a[i]-'0')%3==2)
{
if(dp[i-1][((j-2)%mod+mod)%mod]<dp[i][j])
{
dp[i][j]=dp[i-1][((j-2)%mod+mod)%mod];
pre[i][j]=((j-2)%mod+mod)%mod;
}
}
}
}
if(dp[n-1][0]==n)
{
int flag=0;
for(int i=0;i<n;i++)
{
if(a[i]=='0')flag=1;
}
if(flag==1)printf("0\n");
else printf("-1\n");
continue;
}
int cnt=0;
int now=n-1;
int j=0;
while(now>=1)
{
int pree=pre[now][j];
if(dp[now-1][pree]==dp[now][j])
{
ans[cnt++]=a[now];
}
j=pree;
now--;
if(now==0)
{
if(pree==(a[0]-'0')%3)
{
ans[cnt++]=a[now];
}
}
}
for(int i=cnt-1;i>=0;i--)
{
printf("%c",ans[i]);
}
printf("\n");
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  Codeforces 792C